Package oracle.jdbc

## Enum OracleConnection.ConnectionValidation

- java.lang.Object
- - java.lang.Enum<OracleConnection.ConnectionValidation>
  - - oracle.jdbc.OracleConnection.ConnectionValidation

All Implemented Interfaces:
  `java.io.Serializable`, `java.lang.Comparable<OracleConnection.ConnectionValidation>`

Enclosing interface:
  OracleConnection

    public static enum OracleConnection.ConnectionValidation
    extends java.lang.Enum<OracleConnection.ConnectionValidation>

Specifiers for how much effort to put into validating a `Connection`. The amount of effort put into checking should be non-decreasing from NONE (least effort) to COMPLETE (most effort). Exactly what is checked is implementation dependent.

### Enum Constant Summary

Enum Constants
`COMPLETE` everything that can be checked is working.
`INBAND_DOWN` The JDBC driver validates the connection by reading the inband down event in non-blocking mode.
`LOCAL` `NONE` plus check local resources.
`NETWORK` `SOCKET` plus the network is intact (network PING).
`NONE` isValid fails only if the `Connection` is closed.
`SERVER` `NETWORK` plus significant server processes are running.
`SOCKET` `LOCAL` plus the server isn't obviously unreachable (dead socket).

### Method Summary

All Methods Static Methods Concrete Methods
`static OracleConnection.ConnectionValidation` `valueOf​(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static OracleConnection.ConnectionValidation[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

### Methods inherited from class java.lang.Enum

`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

### Enum Constant Detail

#### NONE

    public static final OracleConnection.ConnectionValidation NONE

isValid fails only if the `Connection` is closed.

#### LOCAL

    public static final OracleConnection.ConnectionValidation LOCAL

`NONE` plus check local resources. Oracle Database same as isUsable.

#### INBAND_DOWN

    public static final OracleConnection.ConnectionValidation INBAND_DOWN

The JDBC driver validates the connection by reading the inband down event in non-blocking mode. If the event is received, it means the server has marked the connection for close i.e. connection is not valid.

#### SOCKET

    public static final OracleConnection.ConnectionValidation SOCKET

`LOCAL` plus the server isn't obviously unreachable (dead socket). Oracle Database JDBC does a lightweight socket check. (ZLD)

#### NETWORK

    public static final OracleConnection.ConnectionValidation NETWORK

`SOCKET` plus the network is intact (network PING). Oracle Database JDBC does a minimum round trip. (OPING)

#### SERVER

    public static final OracleConnection.ConnectionValidation SERVER

`NETWORK` plus significant server processes are running. Oracle Database JDBC does "SELECT 'x' FROM DUAL".

#### COMPLETE

    public static final OracleConnection.ConnectionValidation COMPLETE

everything that can be checked is working. At least `SERVER`. Oracle Database JDBC same as SERVER.

### Method Detail

#### values

    public static OracleConnection.ConnectionValidation[] values()

Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

    for (OracleConnection.ConnectionValidation c : OracleConnection.ConnectionValidation.values())
        System.out.println(c);

Returns:
  an array containing the constants of this enum type, in the order they are declared

#### valueOf

    public static OracleConnection.ConnectionValidation valueOf​(java.lang.String name)

Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
  `java.lang.NullPointerException` - if the argument is null